<?php
/*

 $Id: cname.php,v 1.29 2003/10/23 22:05:26 vollmerk Exp $
 $Source: /a1/cvsroot/maint/docs/cname.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*!
	@header Cname Document
	 The Cname modifying page, this is where we will add/delete modify/view cnames
*/

/* Start House Cleaning */
	require "../modules/config.php";

	if (!check_session()) { logout(); }
		

	setup_user_environment($action, $zone_id);
/* End House Cleaning */

/* Setup the vars we'll need below */
$cname = new Cname($cname_id);
if ($domain_select == "admin") { $domain = new Domain($admin_domain_id); $domain_id = $admin_domain_id; } 
elseif ($domain_id) { $domain = new Domain($domain_id); }
?>

<? show_template('header'); ?>
<p align="left" class="header1">Manage CNAMES</p>
<? 
/***************
 Work If Block 
***************/
/*!
	@function Update
	@discussion Updates a cname
	@param $name	Name of Cname
	@param $server  Server to point it at
	@param $domain_id ID of the domain
	@param $comment Comment on this update
*/
if ($action == "Update")
	{
	// ok were updating, check to make sure data is valid first
	if (strcasecmp($cname->name,$name) OR $domain_id != $cname->domain->id) { 
		$cname->check_name($name, $domain); 
	}

	// if they have changed the server then check it
	if ($cname->server != $server) { 
		$cname->check_server($server);
	} 

        // Make sure they have picked a ttl that is valid
        if (!is_numeric($ttl) || $ttl < 300) {
                $conf['error']->add_error('ttl',"Invalid TTL");
        }

	// if no error and they have access
	if (!$conf['error']->error_state AND $user->has_access($cname->zone->id))  {

		// if the data is valid then update into the database
		$cname->update_domain($domain_id);
		$cname->update_server($server);
		$cname->update_name($name);
		$cname->update_ttl($ttl);
		$cname->object_history->update($user->username,$comment);
		$action_type = "modified";
	}
	
	$action = "show_cname";
		
} // action == update

/*!
	@function really_delete
	@discussion Really delete a cname. 
	@param $cname_id The ID of the cname to delete
*/
elseif ($action == "really_delete") {
	
	// make sure they have access
	if ($user->has_access($cname->zone->id)) {
		$cname->delete_item($cname_id);	
		$conf['ui']->display_confirmation("Deleted CNAME", "That CNAME has been successfully deleted.",	$conf['web_path'] . "/cname.php?action=show_cnames");
	} 
	// bad user no cookie
	else {
		$conf['ui']->show_access_denied();
	}

} // action == really_delete

/*!
	@function really_move
	@discussion Really moves the cname into a different zone. The user must be an admin
	@param $cname_id	ID of the CNAME to be moved
	@param $zone_id		ID of the zone to move it to.
*/
elseif ($action == "really_move") {

	//check one last time to make sure they are a full admin
	if ($user->is_admin) { 
		//they are a admin lets rock and roll!
		$cname->move_cname($cname_id,$zone_id);
		$zone = new Zone($zone_id);
		$conf['ui']->display_confirmation("CNAME $cname->hostname Moved","The CNAME $cname->hostname has been moved to $zone->name.",$conf['web_path'] ."/cname.php?action=show_cname&amp;cname_id=$cname_id");	
	}

} // really_move

/*******************
  DISPLAY IF BLOCK
*******************/


/*!
	@function show_cname
	@discussion show a single cname, also used for editing
	@param $cname_id	ID of the canme to be view/edited
	@param $action_type	Read/Edit/Modified etc...
*/
if ($action == "show_cname" or $action == "edit") {
	$conf['ui']->show_cname($cname,$action_type);
} // show_cname

/*!
	@function show_cnames
	@discussion shows _many_ cnames
	@param $view_zone_id	The ID of the zone to view cnames for
*/
elseif ($action == "show_cnames")
	{

	//if we pass it a zone ID then switch conf to match. 
	if ($view_zone_id) {
		$conf['zone'] = new Zone($view_zone_id);
	}

	// create the view
        $sql = "SELECT id FROM zone_cname WHERE zone=" . $conf['zone']->id;

        if (!$user->view) {
                $user->view = new View($sql);
        }

        if ($sort_type) {
                $user->view->initialize($sort_type,$sort_offset);
        }
        else    {
                $user->view->initialize('id', $sort_offset);
        }
	
	// grab a array of objects
	$cnames = $conf['ui']->get_cnames();
	
	// get the total number of items
	$sql = $user->view->get_sql();
	$total_items = mysql_num_rows(mysql_query($sql, $conf['dbh']));
	if ($total_items > "0") {

		// if there are results run the view
		$conf['script'] = "cname.php";
		$conf['ui']->show_cnames($cnames, $total_items);
	}
	else  {
		echo "<br /><br /><p align=\"center\"><font class=\"header1\">No CNAMES were found in " . $conf['zone']->name . "</font></p>";
		$user->view = false;
	}
} // show_cnames

/*!
	@function delete
	@discussion shows the confirmation check for deleteing the cname
	@param $cname_id	ID of the CNAME to be deleted
*/
elseif ($action == "Delete" || $action == "delete") {

	// ok were deleting, let's check and make sure they are sure
	$conf['ui']->show_confirm( $conf['web_path'] . "/cname.php?action=really_delete&amp;cname_id=$cname_id","Are you sure you want to delete the CNAME $cname->hostname?");
} // delete

/*!
	@function confirm_move
	@discussion shows a confirmation for moving a cname between zones
	@param $zone_id 	ID of zone to move it to
	@param $cname_id	ID of cname to be moved
*/
elseif ($action == "confirm_move") { 

	//ok we are going confirm them move of a cname... 
	$zone = new Zone($zone_id);
	$conf['ui']->show_confirm($conf['web_path'] . "/cname.php?action=really_move&amp;cname_id=$amp;cname_id&amp;zone_id=$zone_id", "Are you sure you want to move $cname->hostname to $zone->name?");

} // confirm_move

show_template('footer'); 

?>
